/* @BABOLO (C)2000, 2001, 2002 http://www.links.ru/~babolo/
 * Free to use, copy or modify while this message included in text
 * and my logo and URL saved in usage().
 * Warranty with special agreement only.
 * $Id: getCGIparm.h,v 1.2 2002/07/03 02:10:33 babolo Exp $
 */

#define DOER 0x0001   /* Error indicate when parameter not found */
#define MATC 0x0002   /* Non-matching result is error            */
#define NONL 0x0004   /* Empty result string is error            */
#define ERRORMASK 0x0007
#define ZERO 0x0008   /* Empty parameter will be substituted     */
#define NOCR 0x0010   /* Delete CR on output                     */
#define NOLF 0x0020   /* Delete LF on output                     */
#define OTST 0x0040   /* No output - test only                   */
#define HOVR 0x0100   /* Hack ON - use SERVER_PROTOCOL           */
#define RTRY 0x0200   /* Retry if empty parameter found          */
#define OPEN 0x8000   /* tofind on pass4 has * at end            */

enum states {d0, d1, d2, v0, v1, v2, vx, dx};
/* d0 -   
   d1 -    - %,  1 
   d2 -  2    
   v0 -  
   v1 -    - %,  1 
   v2 -  2    
   vx -  .
   dx -  
 */

enum classes {no, ok, pc, am, eq, pl, hd, hx, hX, nl, xx};
/* no  
   ok ,    
   pc %
   am &
   eq =
   pl +
   hd  
   hx   
   hX   
   nl \0
   xx
 */

struct patterns
{   u_char *name;
    int namelen;
    int (*test_proc)(u_char *pattern, u_char *query);
};

struct quotens
{   u_char *name;
    int namelen;
    int (*test_proc)(u_char *pattern, u_char *query, u_char **result);
};

int pass1 __P((u_int32_t, u_char **, u_char *, u_char *));
int pass2 __P((u_int32_t, u_char *, u_char *));
int pass3 __P((u_int32_t, u_char *, u_char **));
void pass4 __P((u_int32_t, u_char *, u_char *, u_char *, u_char *));

extern struct patterns patterns[];
extern struct quotens quotens[];
extern u_int32_t automa[xx][dx];
